#!/usr/bin/bash
#
# This file is based on a file from BIND 9.10 package in Fedora 25:
# <https://src.fedoraproject.org/rpms/bind/blob/f25/f/generate-rndc-key.sh>
# licensed under the ISC license. See:
# <https://src.fedoraproject.org/rpms/bind/blob/f25/f/bind.spec>
#

. /etc/rc.d/init.d/functions

# This script generates /etc/rndc.key if doesn't exist, and if there is
# no rndc.conf.

if [ ! -s /etc/loop/rndc.key -a ! -s /etc/loop/rndc.conf ]; then
  echo -n $"Generating /etc/loop/rndc.key:"
  if /usr/bin/rndc-confgen -a -A hmac-sha256 > /dev/null 2>&1
  then
    chmod 640 /etc/loop/rndc.key
    chown root:loop /etc/loop/rndc.key
    success $"/etc/loop/rndc.key generation"
    echo
  else
    failure $"/etc/loop/rndc.key generation"
    echo
  fi
fi
